<?php
/*
Plugin Name: phpBay Pro Plugin for Wordpress
Plugin URI: http://www.wiredstudios.com/phpbay/
Description: Add eBay auction listings to your Wordpress posts.
Version: 2.5.1
Date: April 1st, 2008
Author: Wade Wells
Author URI: http://www.wiredstudios.com
*/ 

#########################################################################
#                                                                       #
#                       phpBay Pro for Wordpress                        #
#                             Wired Studios                             #
#                         www.wiredstudios.com                          #
#                                                                       #
#########################################################################
# COPYRIGHT NOTICE                                                      #
# Copyright 2006-2007 Wired Studios, Inc.  All Rights Reserved.         #
#                                                                       #
# This script may be only used and modified in accordance to the        #
# license agreement attached (eula.txt) except where expressly          #
# noted within commented areas of the code body. This copyright notice  #
# and the comments above and below must remain intact at all times.     #
# By using this code you agree to indemnify Wired Studios, Inc, its     #
# corporate agents and affiliates from any liability that might arise   #
# from its use.                                                         #
#                                                                       #
# Selling the code for this program without prior written consent is    #
# expressly forbidden and in violation of Domestic and International    #
# copyright laws.                                                       #
#########################################################################

function PB_admin_panel() {

# Current Plugin Version
$PB_current_version = '2.5.1';

#################################################

# Update Options if Changed
if (isset($_POST["PB_updated"])) {
  # Get updated/set values
  $PB_aff_type = $_POST["PB_aff_type"];
  $PB_ebay_pid = trim($_POST["PB_ebay_pid"]);
  $PB_ebay_cid = trim($_POST["PB_ebay_cid"]);
  $PB_encode = $_POST["PB_encode"];
  $PB_eb_salic = $_POST["PB_eb_salic"];
  $PB_eb_saatc = $_POST["PB_eb_saatc"];
  $PB_mod_rewrite = $_POST["PB_mod_rewrite"];
  $PB_sort_order = $_POST["PB_sort_order"];
  $PB_eb_siteId = $_POST["PB_eb_siteId"];
  $PB_eb_fbfmt = $_POST["PB_eb_fbfmt"];
  $PB_eb_fcl = $_POST["PB_eb_fcl"];
  $PB_eb_fts = $_POST["PB_eb_fts"];
  $PB_eb_saprclo = $_POST["PB_eb_saprclo"];
  $PB_eb_saprchi = $_POST["PB_eb_saprchi"];
  $PB_eb_sabdlo = $_POST["PB_eb_sabdlo"];
  $PB_eb_sabdhi = $_POST["PB_eb_sabdhi"];
  $PB_eb_fspt = $_POST["PB_eb_fspt"];
  $PB_eb_fpos = $_POST["PB_eb_fpos"];
  $PB_eb_sadis = $_POST["PB_eb_sadis"];
  $PB_eb_sasl_cb = $_POST["PB_eb_sasl_cb"];
  $PB_eb_sasl = $_POST["PB_eb_sasl"];
  $PB_aff_text = $_POST["PB_aff_text"];

  # Update assigned values
  if ($PB_eb_siteId == "") {$PB_eb_siteId = "0";}
  update_option("PB_aff_type",$PB_aff_type);
  update_option("PB_ebay_pid",trim($PB_ebay_pid));
  update_option("PB_ebay_cid",trim($PB_ebay_cid));
  update_option("PB_encode",$PB_encode);
  update_option("PB_eb_salic",$PB_eb_salic);
  update_option("PB_eb_saatc",$PB_eb_saatc);
  update_option("PB_mod_rewrite",$PB_mod_rewrite);
  update_option("PB_sort_order",$PB_sort_order);
  update_option("PB_eb_siteId",$PB_eb_siteId);
  update_option("PB_eb_fbfmt",$PB_eb_fbfmt);
  update_option("PB_eb_fcl",$PB_eb_fcl);
  update_option("PB_eb_fts",$PB_eb_fts);
  update_option("PB_eb_saprclo",$PB_eb_saprclo);
  update_option("PB_eb_saprchi",$PB_eb_saprchi);
  update_option("PB_eb_sabdlo",$PB_eb_sabdlo);
  update_option("PB_eb_sabdhi",$PB_eb_sabdhi);
  update_option("PB_eb_fspt",$PB_eb_fspt);
  update_option("PB_eb_fpos",$PB_eb_fpos);
  update_option("PB_eb_sadis",$PB_eb_sadis);
  update_option("PB_eb_sasl_cb",$PB_eb_sasl_cb);
  update_option("PB_eb_sasl",$PB_eb_sasl);
  update_option("PB_aff_text",$PB_aff_text);
  
  if ($PB_ebay_cid == "") {
    $PB_ebay_cid = "Default campaign";
    update_option("PB_ebay_cid",trim($PB_ebay_cid));
	}

  # Display message that options are updated
  echo '<div id="message" class="updated fade"><p>phpBay options saved.</p></div>';
  
#################################################
} else {
#################################################

  # Load current values
  $PB_aff_type = get_option("PB_aff_type");
  $PB_ebay_pid = trim(get_option("PB_ebay_pid"));
  $PB_ebay_cid = trim(get_option("PB_ebay_cid"));
  $PB_encode = get_option("PB_encode");
  $PB_eb_salic = get_option("PB_eb_salic");
  $PB_eb_saatc = get_option("PB_eb_saatc");
  $PB_mod_rewrite = get_option("PB_mod_rewrite");
  $PB_sort_order = get_option("PB_sort_order");
  $PB_eb_siteId = get_option("PB_eb_siteId");
  $PB_eb_fbfmt = get_option("PB_eb_fbfmt");
  $PB_eb_fcl = get_option("PB_eb_fcl");
  $PB_eb_fts = get_option("PB_eb_fts");
  $PB_eb_saprclo = get_option("PB_eb_saprclo");
  $PB_eb_saprchi = get_option("PB_eb_saprchi");
  $PB_eb_sabdlo = get_option("PB_eb_sabdlo");
  $PB_eb_sabdhi = get_option("PB_eb_sabdhi");
  $PB_eb_fspt = get_option("PB_eb_fspt");
  $PB_eb_fpos = get_option("PB_eb_fpos");
  $PB_eb_sadis = get_option("PB_eb_sadis");
  $PB_eb_sasl_cb = get_option("PB_eb_sasl_cb");
  $PB_eb_sasl = get_option("PB_eb_sasl");
  $PB_aff_text = get_option("PB_aff_text");
  
  if ($PB_eb_siteId == "") {
    $PB_eb_siteId = "0";
	add_option("PB_eb_siteId",$PB_eb_siteId, "", "yes");
    $PB_eb_siteId = get_option("PB_eb_siteId");
	}

  if ($PB_ebay_cid == "") {
    $PB_ebay_cid = "Default campaign";
	}

}
#################################################
# Close the php tag to display the admin panel html
?>
<style type="text/css">
<!--
fieldset { border: 1px solid #666666; padding: 5px; border-color: #c5c5c5; margin: auto; padding: 10px;}
legend { color: #006699; font-weight: bold;}
.prule { height: 1px; background-color:#c5c5c5; width: 100%;
}
-->
</style>
<div class="wrap">
<h2>phpBay Pro Wordpress Plugin Version <?php echo $PB_current_version; ?></h2>
<form method="post">
<fieldset class="options">
  <legend>Affiliate Settings</legend>

  <p><label><strong>Select Affiliate Type:</strong> &nbsp;&nbsp;</label>
  <select name="PB_aff_type">
    <option value="afepn"<?php if ($PB_aff_type == "afepn") {echo " selected";} ?>>Ebay Partner Network</option>
    <option value="afmp"<?php if ($PB_aff_type == "afmp") {echo " selected";} ?>>Mediaplex</option>
    <option value="aftd"<?php if ($PB_aff_type == "aftd") {echo " selected";} ?>>TradeDoubler</option>
    <option value="afan"<?php if ($PB_aff_type == "afan") {echo " selected";} ?>>Affilinet</option>
    <option value="afcj"<?php if ($PB_aff_type == "afcj") {echo " selected";} ?>>Commission Junction</option>
  </select>
  </p>
  
  <p><label><strong>Enter Your Ebay PID (or Campaign ID):</strong> &nbsp;&nbsp;</label>
  <input name="PB_ebay_pid" type="text" value="<?php echo $PB_ebay_pid ?>" maxlength="20" />
  </p>
  <p><label><strong>Enter Your Custom ID:</strong> &nbsp;&nbsp;</label>
  <input name="PB_ebay_cid" type="text" value="<?php echo $PB_ebay_cid ?>" maxlength="20" />
  </p>
</fieldset>

<br /><br />

<fieldset class="options">
<legend>Select Your Preferred Country</legend>
phpBay Pro Wordpress Plugin now supports selling items from Ebay in 14 different countries.  United States is default, but you can select any of the 14 other countries to sell items in your local country of choice.  The currency and language of the country you select will be automatically set.
<br /><br />
<select name="PB_eb_siteId">
<option value="0"<?php if ($PB_eb_siteId == "0") {echo " selected";} ?>>United States</option>
<option value="15"<?php if ($PB_eb_siteId == "15") {echo " selected";} ?>>Australia</option>
<option value="16"<?php if ($PB_eb_siteId == "16") {echo " selected";} ?>>Austria</option>
<option value="123"<?php if ($PB_eb_siteId == "123") {echo " selected";} ?>>Belgium</option>
<option value="2"<?php if ($PB_eb_siteId == "2") {echo " selected";} ?>>Canada</option>
<option value="71"<?php if ($PB_eb_siteId == "71") {echo " selected";} ?>>France</option>
<option value="77"<?php if ($PB_eb_siteId == "77") {echo " selected";} ?>>Germany</option>
<option value="203"<?php if ($PB_eb_siteId == "203") {echo " selected";} ?>>India</option>
<option value="205"<?php if ($PB_eb_siteId == "205") {echo " selected";} ?>>Ireland</option>
<option value="101"<?php if ($PB_eb_siteId == "101") {echo " selected";} ?>>Italy</option>
<option value="146"<?php if ($PB_eb_siteId == "146") {echo " selected";} ?>>Netherlands</option>
<option value="186"<?php if ($PB_eb_siteId == "186") {echo " selected";} ?>>Spain</option>
<option value="193"<?php if ($PB_eb_siteId == "193") {echo " selected";} ?>>Switzerland</option>
<option value="3"<?php if ($PB_eb_siteId == "3") {echo " selected";} ?>>United Kingdom</option>
</select>
</fieldset>

<br /><br />

<fieldset class="options">
<legend>Basic Options</legend>
  <p>These are <strong>optional</strong> basic settings to help fine tune the auction listings returned to your Wordpress blog.</p>

  <p><label><strong>Encrypt Ebay URLs?</strong> &nbsp;&nbsp;</label>
  <input name="PB_encode" type="radio" value="1" <?php if ($PB_encode == "1") {echo "checked";} ?> /> Yes
  <input name="PB_encode" type="radio" value="0" <?php if ($PB_encode == "0") {echo "checked";} ?> /> No
  </p>
  
  <div class="prule"></div>

  <p><input name="PB_eb_fbfmt" type="checkbox" value="1" <?php if ($PB_eb_fbfmt == "1") {echo "checked";} ?> />&nbsp;&nbsp;<label><strong>Display &quot;Buy it Now&quot; Items Only</strong> - To display products that have a &quot;Buy it Now&quot; option <strong>only</strong>, check this box.</label>
</p>

<div class="prule"></div>

  <p><input name="PB_eb_fcl" type="checkbox" value="4" <?php if ($PB_eb_fcl == "4") {echo "checked";} ?> />&nbsp;&nbsp;<label><strong>Display Items with Images Only</strong> - Check this box to display only items that have an image.</label>
 Sometimes an item will have an image, but still display a blank image file.</p>

  <div class="prule"></div>

  <p><input name="PB_mod_rewrite" type="checkbox" value="1" <?php if ($PB_mod_rewrite == "1") {echo "checked";} ?> />&nbsp;&nbsp;<label><strong>Use mod_rewrite on Ebay Images?</strong> - See instructions below for two lines to copy to your .htaccess file if selected.</label></p>

  <div class="prule"></div>

  <p><input name="PB_eb_fts" type="checkbox" value="2" <?php if ($PB_eb_fts == "2") {echo "checked";} ?> />&nbsp;&nbsp;<label><strong>Search Titles AND Descriptions?</strong> - Check this box to search Titles <strong>AND</strong> Descriptions for search terms.</label>
  </p>

</fieldset>

<br /><br />

<fieldset class="options">
<legend>Advanced Options</legend>

  <p>These are <strong>optional</strong> advanced settings to help fine tune the auction listings returned to your Wordpress blog.</p>

  <div class="prule"></div>

  <p><strong>Select Sort Order:</strong><br />
  <select name="PB_sort_order">
  <option value="1"<?php if ($PB_sort_order == "1") {echo " selected";} ?>>Time: ending soonest</option>
  <option value="2"<?php if ($PB_sort_order == "2") {echo " selected";} ?>>Time: newly listed</option>
  <option value="3"<?php if ($PB_sort_order == "3") {echo " selected";} ?>>Price: lowest first</option>
  <option value="4"<?php if ($PB_sort_order == "4") {echo " selected";} ?>>Price: highest first</option>
  </select>
  </p>
  
  <div class="prule"></div>
  
  <p><label><strong>Items Priced:</strong> &nbsp;&nbsp;</label><br />
  Set the minimum and/or maximum item price to display listings.  Use whole numbers without currency symbol.  This is an optional setting that can be left blank.  For example, if your keyword is "mp3 players" and you want to display auctions where the minimum bid value so far is at least 32.00, then enter:  32<br /><br />
  <strong>Minimum:</strong>  &nbsp;&nbsp;<input name="PB_eb_saprclo" type="text" value="<?php echo $PB_eb_saprclo ?>" style="width: 30px;" /> &nbsp;&nbsp;
  <strong>Maximum:</strong>  &nbsp;&nbsp;<input name="PB_eb_saprchi" type="text" value="<?php echo $PB_eb_saprchi ?>" style="width: 30px;" /> &nbsp;&nbsp;
  </p>
  
  <div class="prule"></div>

  <p><label><strong>Number of bids:</strong> &nbsp;&nbsp;</label><br />
  Set the minimum and/or maximum number of bids a listing must have in order to be listed in results.  Use whole numbers.  This is an optional setting that can be left blank.<br /><br />
  <strong>Minimum:</strong>  &nbsp;&nbsp;<input name="PB_eb_sabdlo" type="text" value="<?php echo $PB_eb_sabdlo ?>" style="width: 30px;" /> &nbsp;&nbsp;
  <strong>Maximum:</strong>  &nbsp;&nbsp;<input name="PB_eb_sabdhi" type="text" value="<?php echo $PB_eb_sabdhi ?>" style="width: 30px;" /> &nbsp;&nbsp;
  </p>
  
  <div class="prule"></div>

  <p>
  <input name="PB_eb_sasl_cb" type="checkbox" value="1" <?php if ($PB_eb_sasl_cb == "1") {echo "checked";} ?> />&nbsp;&nbsp;<label><strong>From specific seller (enter sellers' user ID)</strong> &nbsp;&nbsp;</label>
  <input name="PB_eb_sasl" type="text" value="<?php echo $PB_eb_sasl; ?>" maxlength="20" /><br /><br />
  <strong>Note:</strong>  Only one Ebay UserID is supported here.  Leave blank to ignore this setting. Enter a seller's ID here to list items ONLY from that seller. When editing the [phpbay] tag in your page/post edit window, leave the keyword parameter blank to display all items from that seller.
  </p>
  
  <div class="prule"></div>

  <p><input name="PB_eb_fspt" type="checkbox" value="1" <?php if ($PB_eb_fspt == "1") {echo "checked";} ?> />&nbsp;&nbsp;<label>Items within
  <select name="PB_eb_sadis">
  <option value="10"<?php if ($PB_eb_sadis == "10") {echo " selected";} ?>>10</option>
  <option value="25"<?php if ($PB_eb_sadis == "25") {echo " selected";} ?>>25</option>
  <option value="50"<?php if ($PB_eb_sadis == "50") {echo " selected";} ?>>50</option>
  <option value="75"<?php if ($PB_eb_sadis == "75") {echo " selected";} ?>>75</option>
  <option value="100"<?php if ($PB_eb_sadis == "100") {echo " selected";} ?>>100</option>
  <option value="150"<?php if ($PB_eb_sadis == "150") {echo " selected";} ?>>150</option>
  <option value="200"<?php if ($PB_eb_sadis == "200") {echo " selected";} ?>>200</option>
  <option value="250"<?php if ($PB_eb_sadis == "250") {echo " selected";} ?>>250</option>
  <option value="500"<?php if ($PB_eb_sadis == "500") {echo " selected";} ?>>500</option>
  <option value="750"<?php if ($PB_eb_sadis == "750") {echo " selected";} ?>>750</option>
  <option value="1000"<?php if ($PB_eb_sadis == "1000") {echo " selected";} ?>>1000</option>
  <option value="1500"<?php if ($PB_eb_sadis == "1500") {echo " selected";} ?>>1500</option>
  <option value="2000"<?php if ($PB_eb_sadis == "2000") {echo " selected";} ?>>2000</option>
  </select>
  miles of</label><br />
  Zip or Postal Code <input name="PB_eb_fpos" type="text" value="<?php echo $PB_eb_fpos; ?>" maxlength="20" /><br /><br />
  This setting allows you to sell items within a given Zip Code area.  This setting can help focus your niche to a specific metropolitan area, however, it may severely limit the number of items available for sale when zip codes for smaller areas are used.
  </p>

</fieldset>

<br /><br />

<fieldset class="options">
  <legend>phpBay Pro Affiliate Settings</legend>
  <p>Want to earn even more money from phpBay Pro? Join the <a href="http://affiliates.wiredstudios.com/" target="_blank">phpBay Affiliate program by Wired Studios</a> and add even more revenue generating potential to your blog! Each sale you make can earn from $11.70 to $50.00, depending on the sale! Simply signup for the Affiliate program, choose a text or banner affiliate link and paste it below. This link will in turn, appear under each of your Ebay listing blogs, adding an additional way you can earn money with your blog.</p>
<p><strong>Enter your affiliate link:</strong>  
  <input name="PB_aff_text" type="text" value="<?php echo $PB_aff_text; ?>" size="65" /> 
  (leave blank if not used)</p>
</fieldset>

  	<input type="hidden" name="PB_updated" value="1"/>
  	<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options') ?> &raquo;" /></p>
</div>
<p>&nbsp;</p>
<div class="wrap">
  	<h2>phpBay Pro Instructions</h2>
<fieldset class="options">
<legend>General Use</legend>
<p>When writing or editing a post, a new button will appear on the button panel as "pBP" which stands phpBay Pro.  Just place your cursor in the text window where you want to display auctions and press the pBP button and it will insert the pre-formatted code for you.</p>
<p>There are four parameters used in the tag.  The first two parameters must be set, the last two are options.  Put your keywords in the first parameter and the number of auction listings desired as the second parameter.  Example: <br />
<pre>
[phpbay]apple ipod, 10, "", ""[/phpbay]
</pre>
<br />
The third parameter is for a specific Ebay category number.  For example, the specific Ebay category for Apple Ipods is 67833.  So we can confine our search for "apple ipod" to this category like: <br />
<pre>
[phpbay]apple ipod, 10, 67833, ""[/phpbay]
</pre>
<br />
Notice that the "" for the third parameter is not used, but rather replaced with the category number. The "" for the parameters are just a blank placeholder, however, the parameters do not need to be wrapped in "".<br /><br />
The fourth parameter is for words to exclude.  This helps to further fine tune your search by excluding certain words.  For example, if we wanted to exclude "parts" and "case" from our search:<br />
<pre>
[phpbay]apple ipod, 10, 67833, parts case[/phpbay]
</pre>
<br />
Note once again, that ""'s are not used.  For each word to excluded, just separate with a space in the fourth parameter.
</p>
</fieldset>

<br /><br />

<fieldset class="options">
<legend>Using mod_rewrite</legend>
<p>If using the mod_rewrite option to rewrite the Ebay image urls, you will need to edit your .htaccess file and add the following:<br />
<pre>
Options -Indexes
RewriteEngine On
RewriteBase /
RewriteRule ^images/e/(.*)$ http://thumbs.ebaystatic.com/pict/$1 [R,L]
</pre>
Make sure you paste this code BEFORE any Wordpress code in your .htaccess file.  phpBay code should always reside ABOVE any Wordpress code in the .htaccess file.
<br /><br />
It's very important to note the line "RewriteBase /"  This is used for the root directory of a server.  If you installed Wordpress in the root folder of your site, leave that value as-is.  However, if you install your blog into a subdirectory, such as:<br /><br />
<strong>http://www.somesite.com/blog/</strong>
<br /><br />
Then the code you paste into your .htaccess file would look like:
<br />
<pre>
Options -Indexes
RewriteEngine On
<strong>RewriteBase /blog/</strong>
RewriteRule ^images/e/(.*)$ http://thumbs.ebaystatic.com/pict/$1 [R,L]
</pre>
</p>
<p>Copy auction.php to your root folder (where your index.php file is located).  You can rename this file if you like, but you will need to edit ebay.php where auction.php is assigned to a variable.</p>
<p>Preclude search engine bots from following auction.php by adding the following line to your robots.txt file:
<pre>
User-agent: *
Disallow: /auction.php
</pre>
</p>
<p>As of 2.0, SID tracking is introduced.  Wherever you place your SID tracking code, you will need to create a global variable called $sid and assign the SID value to this global variable.  If $sid is set, in your tracking code, it will be picked up by phpBay Pro automatically and passed outbound in with URL masking on or off.</p>
</fieldset>
<p>&nbsp;</p>
<fieldset class="options">
<legend>What's New?</legend>
<p>Multiple keyword support.  Previously, you could use one keyword or keyword phrase.  Now, you can specify multiple keywords for the keyword parameter.  For example, if you wanted to list items that include mustang, camaros and corvettes, just separate each with a | like:  "mustang|camaro|corvette"</p>
<p>Mutliple instances of phpBay in the same post/page or on the index page.  This has been a popular request by many.  You no longer have to worry about using the Wordpress <--more--> tag to prevent multiple listings on the index page.</p>
<p>Several bugs were fixed.  The first was "buy it now" auctions.  When specically checking this box, it would not save the option nor display auctions with BIN options.  Second, there was a bug in the main loop that did not clear out the previous auction settings.  Most of the time, this was overwritten, but in some cases, where an item had a BIN and the next item did not have a BIN, the previous item's BIN would be displayed.  This is now fixed.</p>
<p>Who wants more parameters?  There are quite a few global parameters, as you can see above.  But many wanted to use certain options for certain posts ONLY.  This meant having to set the globally, even though they wanted it for an individual listing. I've now opened up the parameters from the initial four, to a total of eleven now.</p>
<p>The pBP button will still only display the original four parameters, to keep it simple for most users.  For power users, you can expand these four to seven more parameters.  They are, in order:</p>
<ul>
  <li>
      Zip Code - The fifth parameter is if you want to display items near the zip code provided.
  </li>
  <li>
      Seller ID - The sixth parameter is to specify a seller id.  You would use this, if you wanted to dispaly auctions from a specific seller.
  </li>
  <li>
      Minimum Price - The seventh parameter is to specify a minimum bid price, in whole dollars, like:  &quot;5&quot; (represents $5 dollars or currency of the country set in the options above).
  </li>
  <li>
      Maximum Price - The eighth parameter is to specify a maximum bid price, in whole dollars, like:  &quot;200&quot; (represents $200 dollars or currency of the country set in the options above).
  </li>
  <li>
      Minimum Bid - The ninth parameter specifies the minimum bid amount.  For example, if you wanted to display auctions that had at least 4 bids.
  </li>
  <li>
      Maximum Bid - The tenth parameter specifies the maximum bid amount.  For example, if you wanted to display auctions that had no more than 12 bids.
  </li>
  <li>
      Buy It Now - The eleventh parameter specifies if you only want to display items that have a &quot;buy it now&quot; option, set this parameter to 1.
  </li>
  <li>
      SID Tracking - Parameter twelve is used to include a custom SID value for tracking.  This can be tracked per page.
  </li>
</ul>
<p>Of course, you don't have to use all of these.  And if you only need one, just use commas to create blank parameters up to the one you need.  Here are a few examples:</p>
<ul>
  <li>[phpbay]camaro, 10, "", ""[/phpbay] - This is how a typical phpbay code might look.  Four parameters, the first two used, the last two left empty.</li>
  <li>[phpbay][phpbay]camaro, 10, "", "", "", "", "50"[/phpbay] - Here, we extend the parameters to seven total, so we can specify the minimum bid amount must be at least $50.00.  So we set the seventh parameter to "50" .</li>
  <li>[phpbay][phpbay]camaro, 10, "", "", "", "", "50", "", "", "", "1"[/phpbay] - Here, we keep the seventh parameter set to "50" and we use the eleventh parameter to display items that have a "buy it now" option.</li>
  <li>[phpbay]Gardens New Cook Book, 3, "", "", "", "", "", "", "", "", "", "myspecialsid"[/phpbay] - Here, we set a SID tracking value in parameter twelve.</li>
</ul>
</fieldset>
<p>&nbsp;</p>
<p align="center"><small>For updates to this script, Blog Design and Web Design, visit <a href="http://www.wiredstudios.com" target="_blank">Wired Studios</a>.</small></p>
</div>
<?php
} # end PB_admin_panel

#################################################

function add_admin_panel() {
  if (function_exists('add_options_page')) {
    add_options_page('phpBay Pro', 'phpBay Pro', 8, basename(__FILE__), 'PB_admin_panel');
	}
}

#################################################

function phpBayPro($text) {
  global $sid;
  
  if (preg_match_all('%(\\[phpbay\\](.*?)\\[\\/phpbay\\])%', $text, $match)) {
    foreach ($match[0] as $item) {
	
    #if WP is erroneously adding <p></p> tags, let's catch them
    $text = str_replace("<p>[phpbay]", "[phpbay]", $text);
    $text = str_replace("[/phpbay]</p>", "[/phpbay]", $text);

    $params = $item;
    $params = str_replace("[phpbay]", "", $params);
    $params = str_replace("[/phpbay]", "", $params);
	$params = str_replace("&#8220;", "", $params);
	$params = str_replace("&#8221;", "", $params);
	$params = str_replace("&#8243;", "", $params);
    $values = explode(",", $params);
	$kw = trim($values[0]);
    $num = trim($values[1]);
    $cat = trim($values[2]);
    $excl = trim($values[3]);
    $zip = trim($values[4]);
    $seller = trim($values[5]);
	$min_price = trim($values[6]);
	$max_price = trim($values[7]);
	$min_bid = trim($values[8]);
	$max_bid = trim($values[9]);
	$bin = trim($values[10]);
	$psid = trim($values[11]);
	
	# prep the keyword string if searching for multiple items
	if (strpos($kw, "|")) {$kw = "(" . str_replace("|", ",", $kw) . ")";}

	# turn error reporting off in case of a server timeout when connecting to ebay
	error_reporting(0);
	require_once("ebay.php");
	$ebay = new ebay();
	  
	# Set the SID.  You must create a global variable with the name of $sid and assign
	# your SID value to $sid .  If this variable is set in your tracking code, then it
	# will be passed in to phpBay and will be tracked for you.
	if (isset($sid)) {
	  $ebay->eb_sid = $sid;
	}

	# set the number of auction listings to display
	if (intval($num) > 0) {
	  $ebay->eb_frpp = intval($num);
	} else {
	# if number of auction listings to display is not set, then default to 10
	  $ebay->eb_frpp = 10;
	}
	  
	# if there are words to exclude in the search, assign them here.  ie "word1 word2 word3"
	if ($excl > "") {$ebay->eb_exclude = $excl;}
	  
	# Set all global options that are stored in the phpBay Pro Admin Panel
	$ebay->eb_saaff = get_option("PB_aff_type");
	$ebay->eb_pid = get_option("PB_ebay_pid");
	$ebay->eb_cid = urlencode(get_option("PB_ebay_cid"));
	$ebay->site_url = get_bloginfo("wpurl") . "/";
	$ebay->encode = get_option("PB_encode");
	$ebay->eb_salic = get_option("PB_eb_salic");
	$ebay->eb_saatc = get_option("PB_eb_saatc");
	$ebay->mod_rewrite = get_option("PB_mod_rewrite");
	$ebay->eb_aff_text = get_option("PB_aff_text");
	  
	# Set Country Code Information
	$ebay->eb_siteId = get_option("PB_eb_siteId");
	if ($PB_eb_siteId == "") {$PB_eb_siteId = "0";}
	if ($ebay->eb_siteId == "0") {$ebay->eb_language = "en-US";}
	if ($ebay->eb_siteId == "15") {$ebay->eb_language = "en-AU";}
	if ($ebay->eb_siteId == "16") {$ebay->eb_language = "de-AT";}
	if ($ebay->eb_siteId == "123") {$ebay->eb_language = "nl-BE";}
	if ($ebay->eb_siteId == "2") {$ebay->eb_language = "en-CA";}
	if ($ebay->eb_siteId == "71") {$ebay->eb_language = "fr-FR";}
	if ($ebay->eb_siteId == "77") {$ebay->eb_language = "de-DE";}
	if ($ebay->eb_siteId == "203") {$ebay->eb_language = "en-IN";}
	if ($ebay->eb_siteId == "205") {$ebay->eb_language = "";}
	if ($ebay->eb_siteId == "101") {$ebay->eb_language = "it-IT";}
	if ($ebay->eb_siteId == "146") {$ebay->eb_language = "nl-NL";}
	if ($ebay->eb_siteId == "186") {$ebay->eb_language = "es-ES";}
	if ($ebay->eb_siteId == "193") {$ebay->eb_language = "de-CH";}
	if ($ebay->eb_siteId == "3") {$ebay->eb_language = "en-GB";}

	$PB_sort_order = get_option("PB_sort_order");
	if ($PB_sort_order == "1") {$ebay->eb_fsop = "1";$ebay->eb_fsoo = "1";}
	if ($PB_sort_order == "2") {$ebay->eb_fsop = "2";$ebay->eb_fsoo = "2";}
	if ($PB_sort_order == "3") {$ebay->eb_fsop = "3";$ebay->eb_fsoo = "1";}
	if ($PB_sort_order == "4") {$ebay->eb_fsop = "3";$ebay->eb_fsoo = "2";}
	  
	$PB_eb_fcl = get_option("PB_eb_fcl");
	$PB_eb_fts = get_option("PB_eb_fts");
	$PB_eb_saprclo = get_option("PB_eb_saprclo");
	$PB_eb_saprchi = get_option("PB_eb_saprchi");
	$PB_eb_sabdlo = get_option("PB_eb_sabdlo");
	$PB_eb_sabdhi = get_option("PB_eb_sabdhi");
	$PB_eb_fspt = get_option("PB_eb_fspt");
	$PB_eb_fpos = get_option("PB_eb_fpos");
	$PB_eb_sadis = get_option("PB_eb_sadis");
	$PB_eb_sasl_cb = get_option("PB_eb_sasl_cb");
	$PB_eb_sasl = get_option("PB_eb_sasl");
	$PB_eb_fbfmt = get_option("PB_eb_fbfmt");

	# buy it now items
	
	if ($PB_eb_fbfmt == "1") {$ebay->eb_fbfmt = "1"; $ebay->eb_sabfmts = "2";}

	# items with photo only (if set to 4)
	if ($PB_eb_fcl == "4") {$ebay->eb_fcl = "4";} else {$ebay->eb_fcl = "3";}

	# search titles and descriptions (if set to 2)
	if ($PB_eb_fts == "2") {$ebay->eb_fts = "2";} else {$ebay->eb_fts = "";}

	# items by min/max bid price
	if ($PB_eb_saprclo > "") {$ebay->eb_saprclo = urlencode($PB_eb_saprclo);} else {$ebay->eb_saprclo = "";}
	if ($PB_eb_saprchi > "") {$ebay->eb_saprchi = urlencode($PB_eb_saprchi);} else {$ebay->eb_saprchi = "";}

	# items by min/max number of bids
	if ($PB_eb_sabdlo > "") {$ebay->eb_sabdlo = urlencode($PB_eb_sabdlo);$ebay->eb_fbd = "1";} else {$ebay->eb_sabdlo = "";}
	if ($PB_eb_sabdhi > "") {$ebay->eb_sabdhi = urlencode($PB_eb_sabdhi);} else {$ebay->eb_sabdhi = "";}

	# list items by zip code
	if ($PB_eb_fspt == "1") {
	  $ebay->eb_fspt = urlencode($PB_eb_fspt);
	  $ebay->eb_fpos = urlencode($PB_eb_fpos);
	  $ebay->eb_sadis = urlencode($PB_eb_sadis);
	}
	
	#list tiems by specific seller id
	if (($PB_eb_sasl_cb == "1") && ($PB_eb_sasl > "")) {$ebay->eb_sasl = urlencode($PB_eb_sasl);$ebay->eb_fss = "1";} else {$ebay->eb_sasl = "";}
	  

    #################################################
	#          Set extended parameters              #
    #################################################

	# if zip code is set by parameter
	if ($zip > "") {
	  $ebay->eb_fspt = "1";
	  $ebay->eb_fpos = urlencode($zip);
	  $ebay->eb_sadis = "50"; //this is the distance in miles from the zip code to search.
	}

	# if seller id is set by parameter
	if ($seller > "") {$ebay->eb_sasl = urlencode($seller);$ebay->eb_fss = "1";}
	
	# if min price is set by parameter
	if ($min_price > "") {$ebay->eb_saprclo = urlencode($min_price);}

	# if max price is set by parameter
	if ($max_price > "") {$ebay->eb_saprchi = urlencode($max_price);}

	# if min bid is set by parameter
	if ($min_bid > "") {$ebay->eb_sabdlo = urlencode($min_bid);$ebay->eb_fbd = "1";}

	# if max bid is set by parameter
	if ($max_bid > "") {$ebay->eb_sabdhi = urlencode($max_bid);}

	# if BIN is set by parameter
	if ($bin == "1") {$ebay->eb_fbfmt = urlencode($bin);$ebay->eb_sabfmts = "2";}

	# if SID is set by parameter
	if ($psid > "") {$ebay->eb_sid = urlencode($psid);}

    #################################################
	#    Push the GO button and create the magic!   #
    #################################################

	# call the main ebay function, receive the listings in html and replace the phpbay tags with the content
	$ebay->listings($kw, $cat);
	$ebay->html = "<div>\r\n" . $ebay->html . "\r\n</div>\r\n";
	$text = str_replace($item, $ebay->html, $text);
	unset($ebay);
  }
}	  
  return $text;
}


function pb_add_button() {
  $insert_this = '[phpbay]keyword(s), num, \"\", \"\"[/phpbay]';
  phpbay_textbutton_post("", 'pBP', "", $insert_this);
  phpbay_textbutton_page("", 'pBP', "", $insert_this);
}

# Add phpBay auctions to page
add_filter('the_content', 'phpBayPro');
# Add the phpBay Pro Admin Panel
add_action('admin_menu','add_admin_panel');
# Add the phpBay button to the editor 
include('phpbaysnap.php');
add_action('init', 'pb_add_button');

?>
