<?php
/*******************************************************************************
BUTTONSNAP CLASS LIBRARY By Owen Winkler
http://asymptomatic.net
WordPress Downloads are at http://redalt.com/downloads
Version: 1.3.1

Modified by Wired Studios to work with phpBay Pro
*******************************************************************************/

if (!class_exists('phpbay')) :
class phpbay
{
	var $script_output = false;
	var $buttons = array('post'=>array(),'page'=>array(),'any'=>array());
	var $markers = array();
	
	function sink_hooks()
	{
		add_action('edit_form_advanced', array(&$this, 'edit_form_advanced'));
		add_action('edit_page_form', array(&$this, 'edit_page_form'));
		add_filter('mce_plugins', array(&$this, 'mce_plugins'));
		add_action('admin_footer', 'Modify_SwitchEditors_Action');
	}
	
	function go_solo()
	{
		$dispatch = isset($_POST['phpbaydispatch']) ? $_POST['phpbaydispatch'] : @$_GET['phpbaydispatch'];
		if($dispatch != '') {
			auth_redirect();
			$selection = isset($_POST['selection']) ? $_POST['selection'] : @$_GET['selection'];
			$selection = apply_filters($dispatch, $selection);
			die($selection);
		}
		if(isset($_GET['docss'])) {
			auth_redirect();
			do_action('marker_css');
			die();
		}
	}
	
	function edit_form_advanced()
	{
		if (!$this->script_output) {
			$this->output_script('post');
			$this->script_output = true;
		}
	}
	
	function edit_page_form()
	{
		if (!$this->script_output) {
			$this->output_script('page');
			$this->script_output = true;
		}
	}
	
	function mce_plugins($plugins)
	{
		if (count($this->markers) > 0) {
		
			echo "var phpbay_markers = new Array(\n";
			$comma = '';
			foreach ($this->markers as $k => $v) {
				echo "{$comma}\"{$k}\"";
				$comma = "\n,";
			}
			echo "\n);\n";
			echo "var phpbay_classes = new Array(\n";
			$comma = '';
			foreach ($this->markers as $k => $v) {
				echo "{$comma}\"{$v}\"";
				$comma = "\n,";
			}
			echo "\n);\n";
			
?>

function TinyMCE_phpbay_initInstance(inst) {
	tinyMCE.importCSS(inst.getDoc(), "<?php echo $this->plugin_uri(); ?>?docss=true");
}

function TinyMCE_phpbay_parseAttributes(attribute_string) {
	var attributeName = "";
	var attributeValue = "";
	var withInName;
	var withInValue;
	var attributes = new Array();
	var whiteSpaceRegExp = new RegExp('^[ \n\r\t]+', 'g');
	var titleText = tinyMCE.getLang('lang_phpbay_more');
	var titleTextPage = tinyMCE.getLang('lang_phpbay_page');

	if (attribute_string == null || attribute_string.length < 2)
		return null;

	withInName = withInValue = false;

	for (var i=0; i<attribute_string.length; i++) {
		var chr = attribute_string.charAt(i);

		if ((chr == '"' || chr == "'") && !withInValue)
			withInValue = true;
		else if ((chr == '"' || chr == "'") && withInValue) {
			withInValue = false;

			var pos = attributeName.lastIndexOf(' ');
			if (pos != -1)
				attributeName = attributeName.substring(pos+1);

			attributes[attributeName.toLowerCase()] = attributeValue.substring(1).toLowerCase();

			attributeName = "";
			attributeValue = "";
		} else if (!whiteSpaceRegExp.test(chr) && !withInName && !withInValue)
			withInName = true;

		if (chr == '=' && withInName)
			withInName = false;

		if (withInName)
			attributeName += chr;

		if (withInValue)
			attributeValue += chr;
	}

	return attributes;
}

function TinyMCE_phpbay_cleanup(type, content) {
	switch (type) {
		case "initial_editor_insert":
			content = TinyMCE_phpbay_cleanup("insert_to_editor", content);
			alert('foo');
			
			break;
	
		case "insert_to_editor":
			var startPos = 0;

			for(z=0;z<phpbay_markers.length;z++) {
				var startPos = 0;
				while ((startPos = content.indexOf('<!--' + phpbay_markers[z], startPos)) != -1) {
					var adType = "";
					var adTypePos = -1;
					var adTypePos = content.indexOf('#', startPos);
					var endPos = content.indexOf('-->', startPos);
					
					//extract AdManager adType
					if ((adTypePos != -1) && (adTypePos < endPos))
						adType = "<!--" + content.substring(adTypePos, endPos) + "-->";
					//
					
					endPos += 3;
					// Insert image
					var contentAfter = content.substring(endPos);
					content = content.substring(0, startPos);
					content += '<img src="' + (tinyMCE.getParam("theme_href") + "/images/spacer.gif") + '" ';
					content += ' width="100%" ';
					content += 'alt="" class="' + phpbay_classes[z] + '" />';
					content += adType;
					content += contentAfter;
	
					startPos++;
				}
			}
			break;

		case "get_from_editor":
			var startPos = -1;
			while ((startPos = content.indexOf('<img', startPos+1)) != -1) {
				var endPos = content.indexOf('/>', startPos);
				var attribs = TinyMCE_phpbay_parseAttributes(content.substring(startPos + 4, endPos));

				for(z=0;z<phpbay_classes.length;z++) {
					if (attribs['class'] == phpbay_classes[z]) {
						endPos += 2;
						
						// reinstate AdManager adType
						adType = '';
						adTypePos = -1;
						adTypePos = content.indexOf('<!--#',endPos);
						if (adTypePos == endPos) {
							endPos = content.indexOf('-->', adTypePos);
							adType = content.substring(adTypePos + 4, endPos);
							endPos += 3;
						}
						//	
		
						var embedHTML = '<!--' + phpbay_markers[z] + adType + '-->';
		
						// Insert embed/object chunk
						chunkBefore = content.substring(0, startPos);
						chunkAfter = content.substring(endPos);
						content = chunkBefore + embedHTML + chunkAfter;
						break;
					}
				}
			}
			break;
	}

	return content;
}

<?php
			$plugins[] = 'phpbay';
		}
		return $plugins;
	}
	
	function output_script($type = 'any')
	{
		echo '<script type="text/javascript">
		var phpbay_request_uri = "' . $this->plugin_uri() . '";
		var phpbay_wproot = "' . get_settings('siteurl') . '";
		var mceButtonsAdded = 0;
		var qtButtonsAdded = 0;
		</script>' . "\n";
echo <<< ENDSCRIPT

<script type="text/javascript">
addLoadEvent(function () { window.setTimeout('phpbay_addbuttons()',1000); });
var phpbay_mozilla = document.getElementById&&!document.all;
function phpbay_safeclick(e)
{
	if(!phpbay_mozilla) {
		e.returnValue = false;
		e.cancelBubble = true;
	}
}

function phpbay_addEvent( obj, type, fn )
{
	if (obj.addEventListener)
		obj.addEventListener( type, fn, false );
	else if (obj.attachEvent)
	{
		obj["e"+type+fn] = fn;
		obj[type+fn] = function() { obj["e"+type+fn]( window.event ); }
		obj.attachEvent( "on"+type, obj[type+fn] );
	}
}

function phpbay_newbutton(src, alt, qttext) {
	if(window.mcetoolbar) {
		var anchor = document.createElement('A');
		anchor.setAttribute('href', 'javascript:;');
		anchor.setAttribute('title', alt);
		var newimage = document.createElement('IMG');
		newimage.setAttribute('src', src);
		newimage.setAttribute('alt', alt);
		newimage.setAttribute('class', 'mceButtonNormal');
		phpbay_addEvent(newimage, 'mouseover', function() {tinyMCE.switchClass(this,'mceButtonOver');});
		phpbay_addEvent(newimage, 'mouseout', function() {tinyMCE.switchClass(this,'mceButtonNormal');}); //restoreClass(this)
		phpbay_addEvent(newimage, 'mousedown', function() {tinyMCE.restoreAndSwitchClass(this,'mceButtonDown');});
		anchor.appendChild(newimage);
		divs = mcetoolbar.getElementsByTagName('DIV');
		if(divs.length > 0)
			mcetoolbar.insertBefore(anchor, divs[0]);
		else
			mcetoolbar.appendChild(anchor);
		mceButtonsAdded += 1;	
	}
	else if(window.qttoolbar)
	{
		var anchor = document.createElement('input');
		anchor.type = 'button';
		anchor.value = qttext;
		anchor.className = 'ed_button';
		anchor.title = alt;
		anchor.id = 'ed_' + alt;
		qttoolbar.appendChild(anchor);
		qtButtonsAdded += 1;
	}	
	return anchor;
}

function phpbay_newseparator() {
	if(mcetoolbar) {
		var sep = document.createElement('IMG');
  	sep.setAttribute('src', phpbay_wproot + '/wp-includes/js/tinymce/themes/advanced/images/separator.gif');
		sep.className = 'mceSeparatorLine';
		sep.setAttribute('class', 'mceSeparatorLine');
		sep.setAttribute('height', '20');
		sep.setAttribute('width', '2');
		divs = mcetoolbar.getElementsByTagName('DIV');
		if(divs.length > 0)
			mcetoolbar.insertBefore(sep, divs[0]);
		else
			mcetoolbar.appendChild(sep);
	}
}

function phpbay_settext(text) {
	if(window.mcetoolbar) {
		window.tinyMCE.execInstanceCommand('content', 'mceInsertContent', false, text);
		tinyMCE.execCommand("mceCleanup");
	} else {
		edInsertContent(edCanvas, text);
	}
}

function phpbay_ajax(dispatch) {
	if(window.mcetoolbar) {
		selection = tinyMCE.getInstanceById('content').getSelectedText();
	}
	else {	
		if (document.selection) {
			document.getElementById('content').focus();
		  sel = document.selection.createRange();
			if (sel.text.length > 0) {
				selection = sel.text;
			}
			else {
				selection = '';
			}
		}
		else {
			selection = '';
		}
	}

	var ajax = new sack(phpbay_request_uri);
	ajax.setVar('phpbaydispatch', dispatch);
	ajax.setVar('selection', selection);
	ajax.onCompletion = function () {phpbay_settext(this.response);};
	ajax.runAJAX();
}

var mcetoolbar;
var qttoolbar = document.getElementById("ed_toolbar");


function phpbay_addbuttons () {
//	if(window.tinyMCE) {
		try {
      mcetoolbar = document.getElementById('mce_editor_0_toolbar');
		}
		catch(e) {
			setTimeout('phpbay_addbuttons()', 5000);
			return;
		}
//	}

	 try {
	    if(mcetoolbar && mceButtonsAdded==0 || (mcetoolbar==null) && qtButtonsAdded==0){
ENDSCRIPT;
		
		switch($type) {
		case 'any':
			$this->buttons['any'] = array_merge($this->buttons['post'], $this->buttons['page'], $this->buttons['any']);
			break;
		default:
			$this->buttons[$type] = array_merge($this->buttons[$type], $this->buttons['any']);
		}
		$usebuttons = $this->buttons[$type];
		foreach ($usebuttons as $button) {
			if($button['type'] == 'separator') {
				echo "phpbay_newseparator();\n";
			}
			else {
				echo "newbtn = phpbay_newbutton('{$button['src']}', '{$button['alt']}', '{$button['qttext']}');\n";
				switch($button['type']) {
				case 'text':
					echo "phpbay_addEvent(newbtn, 'click', function(e) {phpbay_settext(\"{$button['text']}\");phpbay_safeclick(e);});\n";
					break;
				case 'js':
					echo "phpbay_addEvent(newbtn, 'click', function(e) {" . $button['js'] . "phpbay_safeclick(e);});\n";
					break;
				case 'ajax':
					echo "phpbay_addEvent(newbtn, 'click', function(e) {phpbay_ajax(\"{$button['hook']}\");phpbay_safeclick(e);});\n";
					break;
				default:
					echo "phpbay_addEvent(newbtn, 'click', function(e) {alert(\"The :{$button->type}: button is an invalid type\");phpbay_safeclick(e);});\n";
				}
			}
		}
echo <<< MORESCRIPT
     ButtonsAdded += 1;  
   }
	}
	catch(e) {
		setTimeout('phpbay_addbuttons()', 5000);
	}
	//alert('here');
}
</script>

MORESCRIPT;
	}
	
	function textbutton($imgsrc, $alttext, $inserted, $qttext, $type="any")
	{
	  if ($qttext == '')
	     $qttext = $alttext;  
		$this->buttons[$type][] = array('type'=>'text', 'src'=>$imgsrc, 'alt'=>$alttext, 'text'=>$inserted, 'qttext'=>$qttext);
		return $this->buttons;
	}
	
	function jsbutton($imgsrc, $alttext, $js, $qttext, $type="any")
	{
	  if ($qttext == '')
	     $qttext = 'Testing';//$alttext;
  	$this->buttons[$type][] = array('type'=>'js', 'src'=>$imgsrc, 'alt'=>$alttext, 'js'=>$js, 'qttext'=>$qttext);
		return $this->buttons;
	}

	function ajaxbutton($imgsrc, $alttext, $hook, $qttext, $type="any")
	{
    if ($qttext == '')
	     $qttext = $alttext;
		$this->buttons[$type][] = array('type'=>'ajax', 'src'=>$imgsrc, 'alt'=>$alttext, 'hook'=>$hook, 'qttext'=>$qttext);
		return $this->buttons;
	}
	
	function separator($type="any")
	{
		$this->buttons[$type][] = array('type'=>'separator');
		return $this->buttons;
	}
	
	function register_marker($marker, $cssclass)
	{
		$this->markers[$marker] = $cssclass;
	}
	
	function basename($src='') 
	{
		if($src == '') $src = __FILE__;
		$name = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', $src);
		return str_replace('\\', '/', $name);
	}
	
	function plugin_uri($src = '')
	{
		return get_settings('siteurl') . '/wp-content/plugins/' . $this->basename($src); 
	}
	
	function include_up($filename) {
		$c=0;
		while(!is_file($filename)) {
			$filename = '../' . $filename;
			$c++;
			if($c==30) {
				echo 'Could not find ' . basename($filename) . '.'; return '';
			}
		}
		return $filename;
	}

	function debug($foo)
	{
		$args = func_get_args();
		echo "<pre style=\"background-color:#ffeeee;border:1px solid red;\">";
		foreach($args as $arg1)
		{
			echo htmlentities(print_r($arg1, 1)) . "<br/>";
		}
		echo "</pre>";
	}
}

$phpbay = new phpbay();

function phpbay_textbutton($imgsrc, $alttext, $inserted, $qttext="", $type="any") { global $phpbay; return $phpbay->textbutton($imgsrc, $alttext, $inserted, $qttext, $type);}

function phpbay_jsbutton($imgsrc, $alttext, $js, $qttext="", $type="any") { global $phpbay; return $phpbay->jsbutton($imgsrc, $alttext, $js, $qttext, $type);}

function phpbay_ajaxbutton($imgsrc, $alttext, $hook, $qttext="", $type="any") { global $phpbay; return $phpbay->ajaxbutton($imgsrc, $alttext, $hook, $qttext, $type);}

function phpbay_separator($type="any") { global $phpbay; return $phpbay->separator($type);}



function phpbay_textbutton_post($imgsrc, $alttext, $qttext="", $inserted) { global $phpbay; return $phpbay->textbutton($imgsrc, $alttext, $inserted, $qttext, 'post');}

function phpbay_jsbutton_post($imgsrc, $alttext, $qttext="", $js) { global $phpbay; return $phpbay->jsbutton($imgsrc, $alttext, $js, $qttext, 'post');}

function phpbay_ajaxbutton_post($imgsrc, $alttext, $qttext="", $hook) { global $phpbay; return $phpbay->ajaxbutton($imgsrc, $alttext, $hook, $qttext, 'post');}

function phpbay_separator_post() { global $phpbay; return $phpbay->separator('post');}


function phpbay_textbutton_page($imgsrc, $alttext, $qttext="", $inserted) { global $phpbay; return $phpbay->textbutton($imgsrc, $alttext, $inserted, $qttext, 'page');}

function phpbay_jsbutton_page($imgsrc, $alttext, $qttext="", $js) { global $phpbay; return $phpbay->jsbutton($imgsrc, $alttext, $js, $qttext, 'page');}

function phpbay_ajaxbutton_page($imgsrc, $alttext, $qttext="", $hook) { global $phpbay; return $phpbay->ajaxbutton($imgsrc, $alttext, $hook, $qttext, 'page');}

function phpbay_separator_page() { global $phpbay; return $phpbay->separator('page');}


function phpbay_dirname($src = '') {global $phpbay; return dirname($phpbay->plugin_uri($src));}

function phpbay_register_marker($marker, $cssclass) {global $phpbay; return $phpbay->register_marker($marker, $cssclass);}


/* Tweak to modify the SwitchEditors onClick action .....   */


function Modify_SwitchEditors_Action() { 
  echo "\n".
<<<EOT
<script type="text/javascript">
<!--
	if(edButtonsDiv = document.getElementById("edButtons")){
	   var DivHTML = edButtonsDiv.innerHTML
     DivHTML = DivHTML.replace(/switchEditors\("content"\)/g, "RevisedSwitchEditors(\"content\")");
     edButtonsDiv.innerHTML = DivHTML;
	}
	
function RevisedSwitchEditors(id) {
  switchEditors(id);
  mceButtonsAdded = 0;
  phpbay_addbuttons();	
  return;
}  
//-->
</script>
EOT;
  return;  
} 

endif;

if (!defined('ABSPATH')) {
  require_once($phpbay->include_up('wp-config.php'));
  $phpbay->go_solo();
}
else {
	$phpbay->sink_hooks();
}

?>